/*
 * BasicBall.java
 *
 * Created on September 22, 2005, 9:34 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package mike;

import ballworld.Ball;
import ballworld.World;
import cs101.anim.Animate;

/**
 *
 * @author mw17785
 */
public class BasicBall implements Ball, Animate{
    protected double x;
    protected double y;
    protected double radius;
    protected World world;
    
    /** Creates a new instance of BasicBall */
    public BasicBall() {
        this.radius = 5;
    }

    /**
     * Tells this ball that the user has typed a printable character while
     * this ball was selected.  If the character is not printable (like the
     * arrow or control keys), this method may not be called.
     * @param ch the character that was typed.
     */
    public void userTyped(char ch) {
        if (ch == 'd') {
            this.world.removeBall(this);
        }
    }

    /**
     * Tells this ball about the world to which it has been added.
     * This method will be called immediately after the ball has been added
     * to the world, and before any other methods are called by the world on
     * this ball.
     * @param world the World to which this ball has been added
     */
    public void setWorld(World world) {
        this.world = world;
    }

    /**
     * Tells this ball that the user has dragged or released the mouse at
     * a given location.
     * @param xLoc the x location of the drag or click
     * @param yLoc the y location of the drag or click
     */
    public void userDragged(double xLoc, double yLoc) {
        this.x = xLoc;
        this.y = yLoc;
    }

    /**
     * Gets the y coordinate of the center of the ball.
     * @return the y coordinate of the center of the ball
     */
    public double getY() {
        return this.y;
    }

    /**
     * Gets the x coordinate of the center of the ball.
     * @return the x coordinate of the center of the ball
     */
    public double getX() {
        return this.x;
    }

    /**
     * Gets the radius of the ball.
     * @return the radius of the ball
     */
    public double getRadius() {
        return this.radius;
    }

    /**
     * Performs a single step.  This method is designed to be called
     * repeatedly by an {@link Animator}.  Act should not take too long to
     * complete.
     * @see Animator
     */
    public void act() {
        // do nothing
    }
    
    public String toString() {
        return "A ball at "+x+", "+y;
    }
    
}
